'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var aesthetic = _interopDefault(require('aesthetic'));
var aestheticReact = require('aesthetic-react');
var reactSvg = require('react-svg');
var AphroditeAdapter = _interopDefault(require('aesthetic-adapter-aphrodite'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var reactIs_production_min = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports,"__esModule",{value:!0});
var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?Symbol.for("react.suspense_list"):
60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.fundamental"):60117,w=b?Symbol.for("react.responder"):60118,x=b?Symbol.for("react.scope"):60119;function y(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function z(a){return y(a)===m}
exports.typeOf=y;exports.AsyncMode=l;exports.ConcurrentMode=m;exports.ContextConsumer=k;exports.ContextProvider=h;exports.Element=c;exports.ForwardRef=n;exports.Fragment=e;exports.Lazy=t;exports.Memo=r;exports.Portal=d;exports.Profiler=g;exports.StrictMode=f;exports.Suspense=p;
exports.isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===v||a.$$typeof===w||a.$$typeof===x)};exports.isAsyncMode=function(a){return z(a)||y(a)===l};exports.isConcurrentMode=z;exports.isContextConsumer=function(a){return y(a)===k};exports.isContextProvider=function(a){return y(a)===h};
exports.isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};exports.isForwardRef=function(a){return y(a)===n};exports.isFragment=function(a){return y(a)===e};exports.isLazy=function(a){return y(a)===t};exports.isMemo=function(a){return y(a)===r};exports.isPortal=function(a){return y(a)===d};exports.isProfiler=function(a){return y(a)===g};exports.isStrictMode=function(a){return y(a)===f};exports.isSuspense=function(a){return y(a)===p};
});

unwrapExports(reactIs_production_min);
var reactIs_production_min_1 = reactIs_production_min.typeOf;
var reactIs_production_min_2 = reactIs_production_min.AsyncMode;
var reactIs_production_min_3 = reactIs_production_min.ConcurrentMode;
var reactIs_production_min_4 = reactIs_production_min.ContextConsumer;
var reactIs_production_min_5 = reactIs_production_min.ContextProvider;
var reactIs_production_min_6 = reactIs_production_min.Element;
var reactIs_production_min_7 = reactIs_production_min.ForwardRef;
var reactIs_production_min_8 = reactIs_production_min.Fragment;
var reactIs_production_min_9 = reactIs_production_min.Lazy;
var reactIs_production_min_10 = reactIs_production_min.Memo;
var reactIs_production_min_11 = reactIs_production_min.Portal;
var reactIs_production_min_12 = reactIs_production_min.Profiler;
var reactIs_production_min_13 = reactIs_production_min.StrictMode;
var reactIs_production_min_14 = reactIs_production_min.Suspense;
var reactIs_production_min_15 = reactIs_production_min.isValidElementType;
var reactIs_production_min_16 = reactIs_production_min.isAsyncMode;
var reactIs_production_min_17 = reactIs_production_min.isConcurrentMode;
var reactIs_production_min_18 = reactIs_production_min.isContextConsumer;
var reactIs_production_min_19 = reactIs_production_min.isContextProvider;
var reactIs_production_min_20 = reactIs_production_min.isElement;
var reactIs_production_min_21 = reactIs_production_min.isForwardRef;
var reactIs_production_min_22 = reactIs_production_min.isFragment;
var reactIs_production_min_23 = reactIs_production_min.isLazy;
var reactIs_production_min_24 = reactIs_production_min.isMemo;
var reactIs_production_min_25 = reactIs_production_min.isPortal;
var reactIs_production_min_26 = reactIs_production_min.isProfiler;
var reactIs_production_min_27 = reactIs_production_min.isStrictMode;
var reactIs_production_min_28 = reactIs_production_min.isSuspense;

var reactIs_development = createCommonjsModule(function (module, exports) {



if (process.env.NODE_ENV !== "production") {
  (function() {

Object.defineProperty(exports, '__esModule', { value: true });

// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
// nor polyfill, then a plain number is used for performance.
var hasSymbol = typeof Symbol === 'function' && Symbol.for;
var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
// (unstable) APIs that have been removed. Can we remove the symbols?

var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

function isValidElementType(type) {
  return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
  type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE);
}

/**
 * Forked from fbjs/warning:
 * https://github.com/facebook/fbjs/blob/e66ba20ad5be433eb54423f2b097d829324d9de6/packages/fbjs/src/__forks__/warning.js
 *
 * Only change is we use console.warn instead of console.error,
 * and do nothing when 'console' is not supported.
 * This really simplifies the code.
 * ---
 * Similar to invariant but only logs a warning if the condition is not met.
 * This can be used to log issues in development environments in critical
 * paths. Removing the logging code for production environments will keep the
 * same logic and follow the same code paths.
 */
var lowPriorityWarningWithoutStack = function () {};

{
  var printWarning = function (format) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var argIndex = 0;
    var message = 'Warning: ' + format.replace(/%s/g, function () {
      return args[argIndex++];
    });

    if (typeof console !== 'undefined') {
      console.warn(message);
    }

    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };

  lowPriorityWarningWithoutStack = function (condition, format) {
    if (format === undefined) {
      throw new Error('`lowPriorityWarningWithoutStack(condition, format, ...args)` requires a warning ' + 'message argument');
    }

    if (!condition) {
      for (var _len2 = arguments.length, args = new Array(_len2 > 2 ? _len2 - 2 : 0), _key2 = 2; _key2 < _len2; _key2++) {
        args[_key2 - 2] = arguments[_key2];
      }

      printWarning.apply(void 0, [format].concat(args));
    }
  };
}

var lowPriorityWarningWithoutStack$1 = lowPriorityWarningWithoutStack;

function typeOf(object) {
  if (typeof object === 'object' && object !== null) {
    var $$typeof = object.$$typeof;

    switch ($$typeof) {
      case REACT_ELEMENT_TYPE:
        var type = object.type;

        switch (type) {
          case REACT_ASYNC_MODE_TYPE:
          case REACT_CONCURRENT_MODE_TYPE:
          case REACT_FRAGMENT_TYPE:
          case REACT_PROFILER_TYPE:
          case REACT_STRICT_MODE_TYPE:
          case REACT_SUSPENSE_TYPE:
            return type;

          default:
            var $$typeofType = type && type.$$typeof;

            switch ($$typeofType) {
              case REACT_CONTEXT_TYPE:
              case REACT_FORWARD_REF_TYPE:
              case REACT_LAZY_TYPE:
              case REACT_MEMO_TYPE:
              case REACT_PROVIDER_TYPE:
                return $$typeofType;

              default:
                return $$typeof;
            }

        }

      case REACT_PORTAL_TYPE:
        return $$typeof;
    }
  }

  return undefined;
} // AsyncMode is deprecated along with isAsyncMode

var AsyncMode = REACT_ASYNC_MODE_TYPE;
var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
var ContextConsumer = REACT_CONTEXT_TYPE;
var ContextProvider = REACT_PROVIDER_TYPE;
var Element = REACT_ELEMENT_TYPE;
var ForwardRef = REACT_FORWARD_REF_TYPE;
var Fragment = REACT_FRAGMENT_TYPE;
var Lazy = REACT_LAZY_TYPE;
var Memo = REACT_MEMO_TYPE;
var Portal = REACT_PORTAL_TYPE;
var Profiler = REACT_PROFILER_TYPE;
var StrictMode = REACT_STRICT_MODE_TYPE;
var Suspense = REACT_SUSPENSE_TYPE;
var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

function isAsyncMode(object) {
  {
    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
      hasWarnedAboutDeprecatedIsAsyncMode = true;
      lowPriorityWarningWithoutStack$1(false, 'The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
    }
  }

  return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
}
function isConcurrentMode(object) {
  return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
}
function isContextConsumer(object) {
  return typeOf(object) === REACT_CONTEXT_TYPE;
}
function isContextProvider(object) {
  return typeOf(object) === REACT_PROVIDER_TYPE;
}
function isElement(object) {
  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
}
function isForwardRef(object) {
  return typeOf(object) === REACT_FORWARD_REF_TYPE;
}
function isFragment(object) {
  return typeOf(object) === REACT_FRAGMENT_TYPE;
}
function isLazy(object) {
  return typeOf(object) === REACT_LAZY_TYPE;
}
function isMemo(object) {
  return typeOf(object) === REACT_MEMO_TYPE;
}
function isPortal(object) {
  return typeOf(object) === REACT_PORTAL_TYPE;
}
function isProfiler(object) {
  return typeOf(object) === REACT_PROFILER_TYPE;
}
function isStrictMode(object) {
  return typeOf(object) === REACT_STRICT_MODE_TYPE;
}
function isSuspense(object) {
  return typeOf(object) === REACT_SUSPENSE_TYPE;
}

exports.typeOf = typeOf;
exports.AsyncMode = AsyncMode;
exports.ConcurrentMode = ConcurrentMode;
exports.ContextConsumer = ContextConsumer;
exports.ContextProvider = ContextProvider;
exports.Element = Element;
exports.ForwardRef = ForwardRef;
exports.Fragment = Fragment;
exports.Lazy = Lazy;
exports.Memo = Memo;
exports.Portal = Portal;
exports.Profiler = Profiler;
exports.StrictMode = StrictMode;
exports.Suspense = Suspense;
exports.isValidElementType = isValidElementType;
exports.isAsyncMode = isAsyncMode;
exports.isConcurrentMode = isConcurrentMode;
exports.isContextConsumer = isContextConsumer;
exports.isContextProvider = isContextProvider;
exports.isElement = isElement;
exports.isForwardRef = isForwardRef;
exports.isFragment = isFragment;
exports.isLazy = isLazy;
exports.isMemo = isMemo;
exports.isPortal = isPortal;
exports.isProfiler = isProfiler;
exports.isStrictMode = isStrictMode;
exports.isSuspense = isSuspense;
  })();
}
});

unwrapExports(reactIs_development);
var reactIs_development_1 = reactIs_development.typeOf;
var reactIs_development_2 = reactIs_development.AsyncMode;
var reactIs_development_3 = reactIs_development.ConcurrentMode;
var reactIs_development_4 = reactIs_development.ContextConsumer;
var reactIs_development_5 = reactIs_development.ContextProvider;
var reactIs_development_6 = reactIs_development.Element;
var reactIs_development_7 = reactIs_development.ForwardRef;
var reactIs_development_8 = reactIs_development.Fragment;
var reactIs_development_9 = reactIs_development.Lazy;
var reactIs_development_10 = reactIs_development.Memo;
var reactIs_development_11 = reactIs_development.Portal;
var reactIs_development_12 = reactIs_development.Profiler;
var reactIs_development_13 = reactIs_development.StrictMode;
var reactIs_development_14 = reactIs_development.Suspense;
var reactIs_development_15 = reactIs_development.isValidElementType;
var reactIs_development_16 = reactIs_development.isAsyncMode;
var reactIs_development_17 = reactIs_development.isConcurrentMode;
var reactIs_development_18 = reactIs_development.isContextConsumer;
var reactIs_development_19 = reactIs_development.isContextProvider;
var reactIs_development_20 = reactIs_development.isElement;
var reactIs_development_21 = reactIs_development.isForwardRef;
var reactIs_development_22 = reactIs_development.isFragment;
var reactIs_development_23 = reactIs_development.isLazy;
var reactIs_development_24 = reactIs_development.isMemo;
var reactIs_development_25 = reactIs_development.isPortal;
var reactIs_development_26 = reactIs_development.isProfiler;
var reactIs_development_27 = reactIs_development.isStrictMode;
var reactIs_development_28 = reactIs_development.isSuspense;

var reactIs = createCommonjsModule(function (module) {

if (process.env.NODE_ENV === 'production') {
  module.exports = reactIs_production_min;
} else {
  module.exports = reactIs_development;
}
});

/**
 * Copyright 2015, Yahoo! Inc.
 * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
 */
var REACT_STATICS = {
  childContextTypes: true,
  contextType: true,
  contextTypes: true,
  defaultProps: true,
  displayName: true,
  getDefaultProps: true,
  getDerivedStateFromError: true,
  getDerivedStateFromProps: true,
  mixins: true,
  propTypes: true,
  type: true
};
var KNOWN_STATICS = {
  name: true,
  length: true,
  prototype: true,
  caller: true,
  callee: true,
  arguments: true,
  arity: true
};
var FORWARD_REF_STATICS = {
  '$$typeof': true,
  render: true,
  defaultProps: true,
  displayName: true,
  propTypes: true
};
var MEMO_STATICS = {
  '$$typeof': true,
  compare: true,
  defaultProps: true,
  displayName: true,
  propTypes: true,
  type: true
};
var TYPE_STATICS = {};
TYPE_STATICS[reactIs.ForwardRef] = FORWARD_REF_STATICS;
TYPE_STATICS[reactIs.Memo] = MEMO_STATICS;

function getStatics(component) {
  // React v16.11 and below
  if (reactIs.isMemo(component)) {
    return MEMO_STATICS;
  } // React v16.12 and above


  return TYPE_STATICS[component['$$typeof']] || REACT_STATICS;
}

var defineProperty = Object.defineProperty;
var getOwnPropertyNames = Object.getOwnPropertyNames;
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
var getPrototypeOf = Object.getPrototypeOf;
var objectPrototype = Object.prototype;
function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
  if (typeof sourceComponent !== 'string') {
    // don't hoist over string (html) components
    if (objectPrototype) {
      var inheritedComponent = getPrototypeOf(sourceComponent);

      if (inheritedComponent && inheritedComponent !== objectPrototype) {
        hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
      }
    }

    var keys = getOwnPropertyNames(sourceComponent);

    if (getOwnPropertySymbols) {
      keys = keys.concat(getOwnPropertySymbols(sourceComponent));
    }

    var targetStatics = getStatics(targetComponent);
    var sourceStatics = getStatics(sourceComponent);

    for (var i = 0; i < keys.length; ++i) {
      var key = keys[i];

      if (!KNOWN_STATICS[key] && !(blacklist && blacklist[key]) && !(sourceStatics && sourceStatics[key]) && !(targetStatics && targetStatics[key])) {
        var descriptor = getOwnPropertyDescriptor(sourceComponent, key);

        try {
          // Avoid failures from read-only properties
          defineProperty(targetComponent, key, descriptor);
        } catch (e) {}
      }
    }
  }

  return targetComponent;
}

var hoistNonReactStatics_cjs = hoistNonReactStatics;

var rngBrowser = createCommonjsModule(function (module) {
// Unique ID creation requires a high quality random # generator.  In the
// browser this is a little complicated due to unknown quality of Math.random()
// and inconsistent support for the `crypto` API.  We do the best we can via
// feature-detection

// getRandomValues needs to be invoked in a context where "this" is a Crypto
// implementation. Also, find the complete implementation of crypto on IE11.
var getRandomValues = (typeof(crypto) != 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto)) ||
                      (typeof(msCrypto) != 'undefined' && typeof window.msCrypto.getRandomValues == 'function' && msCrypto.getRandomValues.bind(msCrypto));

if (getRandomValues) {
  // WHATWG crypto RNG - http://wiki.whatwg.org/wiki/Crypto
  var rnds8 = new Uint8Array(16); // eslint-disable-line no-undef

  module.exports = function whatwgRNG() {
    getRandomValues(rnds8);
    return rnds8;
  };
} else {
  // Math.random()-based (RNG)
  //
  // If all else fails, use Math.random().  It's fast, but is of unspecified
  // quality.
  var rnds = new Array(16);

  module.exports = function mathRNG() {
    for (var i = 0, r; i < 16; i++) {
      if ((i & 0x03) === 0) r = Math.random() * 0x100000000;
      rnds[i] = r >>> ((i & 0x03) << 3) & 0xff;
    }

    return rnds;
  };
}
});

/**
 * Convert array of 16 byte values to UUID string format of the form:
 * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
 */
var byteToHex = [];
for (var i = 0; i < 256; ++i) {
  byteToHex[i] = (i + 0x100).toString(16).substr(1);
}

function bytesToUuid(buf, offset) {
  var i = offset || 0;
  var bth = byteToHex;
  // join used to fix memory issue caused by concatenation: https://bugs.chromium.org/p/v8/issues/detail?id=3175#c4
  return ([
    bth[buf[i++]], bth[buf[i++]],
    bth[buf[i++]], bth[buf[i++]], '-',
    bth[buf[i++]], bth[buf[i++]], '-',
    bth[buf[i++]], bth[buf[i++]], '-',
    bth[buf[i++]], bth[buf[i++]], '-',
    bth[buf[i++]], bth[buf[i++]],
    bth[buf[i++]], bth[buf[i++]],
    bth[buf[i++]], bth[buf[i++]]
  ]).join('');
}

var bytesToUuid_1 = bytesToUuid;

function v4(options, buf, offset) {
  var i = buf && offset || 0;

  if (typeof(options) == 'string') {
    buf = options === 'binary' ? new Array(16) : null;
    options = null;
  }
  options = options || {};

  var rnds = options.random || (options.rng || rngBrowser)();

  // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`
  rnds[6] = (rnds[6] & 0x0f) | 0x40;
  rnds[8] = (rnds[8] & 0x3f) | 0x80;

  // Copy bytes to buffer, if provided
  if (buf) {
    for (var ii = 0; ii < 16; ++ii) {
      buf[i + ii] = rnds[ii];
    }
  }

  return buf || bytesToUuid_1(rnds);
}

var v4_1 = v4;

var hasOwn = Object.prototype.hasOwnProperty;
var toStr = Object.prototype.toString;
var defineProperty$1 = Object.defineProperty;
var gOPD = Object.getOwnPropertyDescriptor;

var isArray = function isArray(arr) {
	if (typeof Array.isArray === 'function') {
		return Array.isArray(arr);
	}

	return toStr.call(arr) === '[object Array]';
};

var isPlainObject = function isPlainObject(obj) {
	if (!obj || toStr.call(obj) !== '[object Object]') {
		return false;
	}

	var hasOwnConstructor = hasOwn.call(obj, 'constructor');
	var hasIsPrototypeOf = obj.constructor && obj.constructor.prototype && hasOwn.call(obj.constructor.prototype, 'isPrototypeOf');
	// Not own constructor property must be Object
	if (obj.constructor && !hasOwnConstructor && !hasIsPrototypeOf) {
		return false;
	}

	// Own properties are enumerated firstly, so to speed up,
	// if last one is own, then all properties are own.
	var key;
	for (key in obj) { /**/ }

	return typeof key === 'undefined' || hasOwn.call(obj, key);
};

// If name is '__proto__', and Object.defineProperty is available, define __proto__ as an own property on target
var setProperty = function setProperty(target, options) {
	if (defineProperty$1 && options.name === '__proto__') {
		defineProperty$1(target, options.name, {
			enumerable: true,
			configurable: true,
			value: options.newValue,
			writable: true
		});
	} else {
		target[options.name] = options.newValue;
	}
};

// Return undefined instead of __proto__ if '__proto__' is not an own property
var getProperty = function getProperty(obj, name) {
	if (name === '__proto__') {
		if (!hasOwn.call(obj, name)) {
			return void 0;
		} else if (gOPD) {
			// In early versions of node, obj['__proto__'] is buggy when obj has
			// __proto__ as an own property. Object.getOwnPropertyDescriptor() works.
			return gOPD(obj, name).value;
		}
	}

	return obj[name];
};

var extend = function extend() {
	var options, name, src, copy, copyIsArray, clone;
	var target = arguments[0];
	var i = 1;
	var length = arguments.length;
	var deep = false;

	// Handle a deep copy situation
	if (typeof target === 'boolean') {
		deep = target;
		target = arguments[1] || {};
		// skip the boolean and the target
		i = 2;
	}
	if (target == null || (typeof target !== 'object' && typeof target !== 'function')) {
		target = {};
	}

	for (; i < length; ++i) {
		options = arguments[i];
		// Only deal with non-null/undefined values
		if (options != null) {
			// Extend the base object
			for (name in options) {
				src = getProperty(target, name);
				copy = getProperty(options, name);

				// Prevent never-ending loop
				if (target !== copy) {
					// Recurse if we're merging plain objects or arrays
					if (deep && copy && (isPlainObject(copy) || (copyIsArray = isArray(copy)))) {
						if (copyIsArray) {
							copyIsArray = false;
							clone = src && isArray(src) ? src : [];
						} else {
							clone = src && isPlainObject(src) ? src : {};
						}

						// Never move original objects, clone them
						setProperty(target, { name: name, newValue: extend(deep, clone, copy) });

					// Don't bring in undefined values
					} else if (typeof copy !== 'undefined') {
						setProperty(target, { name: name, newValue: copy });
					}
				}
			}
		}
	}

	// Return the modified object
	return target;
};

/**
 * Wrap a React component with an HOC that injects the defined style sheet as a prop.
 */
function withStyles(styleSheet, options) {
    if (options === void 0) { options = { extendable: true }; }
    var _a = options.cxPropName, cxPropName = _a === void 0 ? aesthetic.options.cxPropName : _a, _b = options.extendable, extendable = _b === void 0 ? aesthetic.options.extendable : _b, _c = options.extendFrom, extendFrom = _c === void 0 ? "" : _c, _d = options.passThemeProp, passThemeProp = _d === void 0 ? aesthetic.options.passThemeProp : _d, _e = options.stylesPropName, stylesPropName = _e === void 0 ? aesthetic.options.stylesPropName : _e, _f = options.themePropName, themePropName = _f === void 0 ? aesthetic.options.themePropName : _f;
    return function withStylesComposer(WrappedComponent) {
        var baseName = WrappedComponent.displayName || WrappedComponent.name;
        var styleName = baseName + "-" + v4_1();
        // We must register earlier so that extending styles works correctly
        aesthetic.registerStyleSheet(styleName, styleSheet, extendFrom);
        var WithStyles = React__default.memo(function WithStyles(props) {
            var _a;
            var themeName = aesthetic.getTheme();
            var mergedStylesheet = extend(true, {}, aesthetic.getStyleSheet(styleName, themeName.name || "default_theme"), styleSheet(aesthetic.getTheme()), props.parentStylesheet
                ? props.parentStylesheet(aesthetic.getTheme())
                : {});
            var _b = aestheticReact.useStyles(function () { return mergedStylesheet; }), styles = _b[0], cx = _b[1];
            var extraProps = (_a = {},
                _a[cxPropName] = cx,
                _a[stylesPropName] = styles,
                _a);
            if (passThemeProp) {
                extraProps[themePropName] = aesthetic.getTheme(themeName.name);
            }
            extraProps.parentStylesheet = styleSheet;
            return React__default.createElement(WrappedComponent, __assign({}, props, extraProps));
        });
        hoistNonReactStatics_cjs(WithStyles, WrappedComponent);
        WithStyles.displayName = "withStyles(" + baseName + ")";
        WithStyles.styleName = styleName;
        WithStyles.WrappedComponent = WrappedComponent;
        // eslint-disable-next-line @typescript-eslint/unbound-method
        WithStyles.extendStyles = function (customStyleSheet, extendOptions) {
            if (!extendable) {
                throw new Error(baseName + " is not extendable.");
            }
            return withStyles(customStyleSheet, __assign(__assign(__assign({}, options), extendOptions), { extendFrom: styleName }))(WrappedComponent);
        };
        return WithStyles;
    };
}

var useTheme = function () { return aestheticReact.useTheme(); };

var styleSheet = function (theme) { return ({
    h1: __assign({}, theme.typography.h1),
    h2: __assign({}, theme.typography.h2),
    h3: __assign({}, theme.typography.h3),
    h4: __assign({}, theme.typography.h4),
    h5: __assign({}, theme.typography.h5),
    buttonText: __assign({}, theme.typography.buttonText),
    body: __assign({}, theme.typography.body),
    bodyHighlight: __assign({}, theme.typography.bodyHighlight),
    descriptionMedium: __assign({}, theme.typography.descriptionMedium),
    label: __assign({}, theme.typography.label)
}); };
var H1 = function (_a) {
    var children = _a.children, className = _a.className, props = __rest(_a, ["children", "className"]);
    var _b = aestheticReact.useStyles(styleSheet), styles = _b[0], cx = _b[1];
    return (React__default.createElement("h1", __assign({ className: cx(styles.h1, className) }, props), children));
};
var H2 = function (_a) {
    var children = _a.children, className = _a.className, props = __rest(_a, ["children", "className"]);
    var _b = aestheticReact.useStyles(styleSheet), styles = _b[0], cx = _b[1];
    return (React__default.createElement("h2", __assign({ className: cx(styles.h2, className) }, props), children));
};
var H3 = function (_a) {
    var children = _a.children, className = _a.className, props = __rest(_a, ["children", "className"]);
    var _b = aestheticReact.useStyles(styleSheet), styles = _b[0], cx = _b[1];
    return (React__default.createElement("h3", __assign({ className: cx(styles.h3, className) }, props), children));
};
var ButtonText = function (_a) {
    var children = _a.children, className = _a.className, props = __rest(_a, ["children", "className"]);
    var _b = aestheticReact.useStyles(styleSheet), styles = _b[0], cx = _b[1];
    return (React__default.createElement("span", __assign({ className: cx(styles.buttonText, className) }, props), children));
};
var Text = function (_a) {
    var children = _a.children, className = _a.className, props = __rest(_a, ["children", "className"]);
    var _b = aestheticReact.useStyles(styleSheet), styles = _b[0], cx = _b[1];
    return (React__default.createElement("span", __assign({ className: cx(styles.body, className) }, props), children));
};
var TextHighlight = function (_a) {
    var children = _a.children, className = _a.className, props = __rest(_a, ["children", "className"]);
    var _b = aestheticReact.useStyles(styleSheet), styles = _b[0], cx = _b[1];
    return (React__default.createElement("span", __assign({ className: cx(styles.bodyHighlight, className) }, props), children));
};
var DescriptionMedium = function (_a) {
    var children = _a.children, className = _a.className, props = __rest(_a, ["children", "className"]);
    var _b = aestheticReact.useStyles(styleSheet), styles = _b[0], cx = _b[1];
    return (React__default.createElement("span", __assign({ className: cx(styles.descriptionMedium, className) }, props), children));
};
var Label = function (_a) {
    var children = _a.children, className = _a.className, props = __rest(_a, ["children", "className"]);
    var _b = aestheticReact.useStyles(styleSheet), styles = _b[0], cx = _b[1];
    return (React__default.createElement("span", __assign({ className: cx(styles.label, className) }, props), children));
};

var styleSheet$1 = function (theme) { return ({
    button: {
        color: theme.colors.primary,
        cursor: "pointer",
        outlineStyle: "none",
        display: "flex",
        alignItems: "center"
    },
    danger: {},
    disabled: {}
}); };
var BaseButton = function (_a) {
    var styles = _a.styles, cx = _a.cx, danger = _a.danger, className = _a.className, children = _a.children, renderLeftIcon = _a.renderLeftIcon, renderRightIcon = _a.renderRightIcon, wrappedRef = _a.wrappedRef, parentStylesheet = _a.parentStylesheet, props = __rest(_a, ["styles", "cx", "danger", "className", "children", "renderLeftIcon", "renderRightIcon", "wrappedRef", "parentStylesheet"]);
    var disabled = props.disabled;
    var styleArray = [danger && styles.danger, disabled && styles.disabled];
    return (React__default.createElement("button", __assign({ className: cx.apply(void 0, __spreadArrays([styles.button], styleArray, [className])), type: "submit" }, props, { ref: wrappedRef }),
        renderLeftIcon && renderLeftIcon(),
        React__default.createElement(ButtonText, null, children),
        renderRightIcon && renderRightIcon()));
};
// const ForwardedButton = React.forwardRef<
//   IProps & WithStylesProps,
//   HTMLButtonElement
// >((props: any, ref) => <BaseButton wrappedRef={ref} {...props} />);
// ForwardedButton.displayName = "BaseButton";
var BaseButton$1 = withStyles(styleSheet$1)(BaseButton);

var styleSheet$2 = function (theme) { return ({
    chip: {
        padding: theme.spaceUnit.xs,
        outlineStyle: "none",
        border: "1px solid",
        borderRadius: "4px",
        boxSizing: "border-box",
        display: "flex",
        alignItems: "center",
        borderColor: theme.colors.grey.grey50
    },
    text: {},
    selected: {
        backgroundColor: theme.colors.grey.grey100
    },
    clickable: {
        cursor: "pointer",
        ":hover": {
            backgroundColor: theme.colors.grey.grey25
        }
    },
    disabled: {
        pointerEvents: "none",
        color: theme.colors.grey.grey50
    }
}); };
var BaseChip = function (_a) {
    var styles = _a.styles, cx = _a.cx, selected = _a.selected, disabled = _a.disabled, renderLeftIcon = _a.renderLeftIcon, renderRightIcon = _a.renderRightIcon, children = _a.children, className = _a.className, wrappedRef = _a.wrappedRef, parentStylesheet = _a.parentStylesheet, props = __rest(_a, ["styles", "cx", "selected", "disabled", "renderLeftIcon", "renderRightIcon", "children", "className", "wrappedRef", "parentStylesheet"]);
    var onClick = props.onClick;
    var styleArray = cx(styles.chip, onClick && styles.clickable, selected && styles.selected, disabled && styles.disabled, className);
    return (React__default.createElement("div", __assign({ className: styleArray }, props),
        renderLeftIcon && renderLeftIcon(),
        React__default.createElement(DescriptionMedium, { className: cx(styles.text) }, children),
        renderRightIcon && renderRightIcon()));
};
var BaseChip$1 = withStyles(styleSheet$2)(BaseChip);

function extendStyles() {
    var styleSheets = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        styleSheets[_i] = arguments[_i];
    }
    return aesthetic.extendStyles.apply(aesthetic, styleSheets);
}

var colorMap = function (theme) { return ({
    default: {
        chip: {
            borderColor: theme.colors.grey.grey50
        },
        selected: {
            backgroundColor: theme.colors.grey.grey50
        }
    },
    success: {
        chip: {
            borderColor: theme.colors.success.success100
        },
        selected: {
            backgroundColor: theme.colors.success.success100
        }
    },
    warning: {
        chip: {
            borderColor: theme.colors.warning.warning100
        },
        selected: {
            backgroundColor: theme.colors.warning.warning100
        }
    },
    danger: {
        chip: {
            borderColor: theme.colors.alert.alert100
        },
        selected: {
            backgroundColor: theme.colors.alert.alert100
        }
    }
}); };
var StatusChip = function (_a) {
    var styleSheet = _a.styleSheet, type = _a.type, props = __rest(_a, ["styleSheet", "type"]);
    var styleSheet2 = extendStyles(function (theme) { return (__assign({}, colorMap(theme)[type])); }, function (theme) { return (styleSheet ? styleSheet(theme) : {}); });
    var AlteredBaseChip = BaseChip$1.extendStyles(styleSheet2);
    return React__default.createElement(AlteredBaseChip, __assign({}, props));
};

var styleSheet$3 = function () { return ({
    icon: {
        display: "block",
        "> div": {
            display: "flex"
        }
    }
}); };
var Icon = function (_a) {
    var name = _a.name, height = _a.height, width = _a.width, _b = _a.stroke, stroke = _b === void 0 ? "black" : _b, fill = _a.fill, color = _a.color, className = _a.className, src = _a.src, size = _a.size;
    var theme = aestheticReact.useTheme();
    var svgIcon = src || (theme && "assets/icons/" + theme.icons[name]);
    var _c = aestheticReact.useStyles(styleSheet$3), styles = _c[0], cx = _c[1];
    return (React__default.createElement(reactSvg.ReactSVG, { src: svgIcon, className: cx(styles.icon), beforeInjection: function (svg) {
            svg.setAttribute("class", "y-icon");
            svg.setAttribute("class", svg.getAttribute("class") + " " + className);
            if (size) {
                svg.setAttribute("height", size.toString());
                svg.setAttribute("width", size.toString());
            }
            if (height) {
                svg.setAttribute("height", height.toString());
            }
            if (width) {
                svg.setAttribute("width", width.toString());
            }
            if (stroke) {
                svg.setAttribute("stroke", stroke);
            }
            if (fill) {
                svg.setAttribute("fill", fill);
            }
            if (color) {
                svg.setAttribute("fill", color);
                svg.setAttribute("stroke", color);
            }
        } }));
};

var styleSheet$4 = function (theme) { return ({
    chip: {
        borderColor: "green"
    },
    deleteIcon: {
        padding: theme.spaceUnit.xxs,
        marginLeft: theme.spaceUnit.xs,
        cursor: "pointer",
        borderRadius: "50%",
        ":hover": {
            backgroundColor: "red"
        }
    }
}); };
var CloseableChipStyle = BaseChip$1.extendStyles(styleSheet$4);
var CloseableChipComponent = function (_a) {
    var _b = _a.onClose, onClose = _b === void 0 ? function () { } : _b, renderRightIcon = _a.renderRightIcon, styles = _a.styles, cx = _a.cx, props = __rest(_a, ["onClose", "renderRightIcon", "styles", "cx"]);
    return (React__default.createElement(CloseableChipStyle, __assign({}, props, { renderRightIcon: function () { return (React__default.createElement("div", { onClick: function (e) {
                onClose();
                e.stopPropagation();
            }, className: cx(styles.deleteIcon) }, renderRightIcon ? (renderRightIcon()) : (React__default.createElement(Icon, { name: "close", size: 12 })))); } })));
};
var CloseableChip = withStyles(styleSheet$4)(CloseableChipComponent);

var styleSheet$5 = function (theme) { return ({
    input: {
        color: theme.colors.primary,
        cursor: "pointer",
        ":hover": {},
        ":active": {},
        "@selectors": {
            "&.checked": {},
            "&.disabled": {
                cursor: "default"
            },
            "&.error": {}
        }
    },
    label: {
        cursor: "pointer",
        ":hover": {},
        ":active": {},
        "@selectors": {
            "&.checked": {},
            "&.disabled": {
                cursor: "default"
            },
            "&.error": {
                color: theme.colors.alert.alert50
            }
        }
    },
    wrapper: {
        display: "flex",
        alignItems: "center",
        "@selectors": {
            "&.checked": {},
            "&.disabled": {},
            "&.error": {
                color: theme.colors.alert.alert50
            }
        }
    }
}); };
var Radio = function (_a) {
    var children = _a.children, cx = _a.cx, hasError = _a.hasError, label = _a.label, selectedValue = _a.selectedValue, styles = _a.styles, wrappedRef = _a.wrappedRef, onValueSelect = _a.onValueSelect, props = __rest(_a, ["children", "cx", "hasError", "label", "selectedValue", "styles", "wrappedRef", "onValueSelect"]);
    var id = React.useMemo(function () { return v4_1(); }, []);
    var value = props.value, disabled = props.disabled;
    var isChecked = selectedValue === value;
    var handleChange = React.useCallback(function () {
        if (!disabled && onValueSelect) {
            onValueSelect(value);
        }
    }, [disabled, value, onValueSelect]);
    var inputStyles = cx(styles.input, isChecked && "checked", disabled && "disabled", hasError && "error", children && children.props.className);
    return (React__default.createElement("div", { className: cx(styles.wrapper) },
        React__default.createElement("input", __assign({ checked: isChecked, className: children ? cx({ display: "none" }) : inputStyles, id: id, ref: wrappedRef, type: "radio", onChange: handleChange }, props)),
        children &&
            React__default.cloneElement(children, {
                className: inputStyles,
                onClick: handleChange
            }),
        React__default.createElement("label", { htmlFor: id, className: cx(styles.label, isChecked && "checked", disabled && "disabled", hasError && "error") }, label)));
};
var Radio$1 = withStyles(styleSheet$5)(Radio);

var styleSheet$6 = function () { return ({
    radioGroup: {
        display: "flex",
        flexDirection: "column",
        justifyContent: "space-between"
    }
}); };
var RadioGroup = function (_a) {
    var children = _a.children, cx = _a.cx, styles = _a.styles, props = __rest(_a, ["children", "cx", "styles"]);
    return (React__default.createElement("div", { className: cx(styles.radioGroup) }, React__default.Children.map(children, function (child) {
        return React__default.cloneElement(child, __assign({}, props));
    })));
};
var RadioGroup$1 = withStyles(styleSheet$6)(RadioGroup);

var stylesheet = function (theme) { return ({
    fieldset: {
        position: "relative",
        height: 38,
        display: "flex",
        padding: "2px 8px",
        "@selectors": {
            "&.error": {
                borderColor: theme.colors.alert.alert100
            },
            "&.disabled": {
                backgroundColor: "#eee"
            },
            "&.focus": {}
        }
    },
    input: __assign(__assign({ outline: "none", border: "none", width: "100%", height: 35, flex: 1 }, theme.typography.body), { "@selectors": {
            "&.disabled": {
                backgroundColor: "#eee"
            }
        } }),
    labelContainer: {
        position: "absolute",
        top: "0px",
        left: "4px",
        height: "40px",
        pointerEvents: "none",
        display: "flex",
        alignItems: "center"
    },
    label: __assign(__assign({ whiteSpace: "nowrap", overflow: "hidden", textOverflow: "ellipsis", color: "#808080", padding: "0px 4px", transition: "transform 0.1s, font-size 0.1s", transitionTimingFunction: "ease-in", pointerEvents: "none" }, theme.typography.body), { "@selectors": {
            "&.active,&.focus": __assign({ transform: "translate(2px, -21px)" }, theme.typography.label)
        } }),
    hiddenLabel: __assign({ opacity: "0", position: "absolute", pointerEvents: "none", height: "0" }, theme.typography.label),
    legend: {
        width: "0",
        pointerEvents: "none",
        padding: "0",
        textAlign: "left",
        opacity: 0,
        transition: "width 0.15s",
        lineHeight: "11px",
        height: 0,
        "@selectors": {
            "&.active,&.focus": {
                padding: "0 2px"
            }
        }
    }
}); };
var TextInput = function (_a) {
    var styles = _a.styles, wrappedRef = _a.wrappedRef, cx = _a.cx, className = _a.className, hasError = _a.hasError, label = _a.label, onChange = _a.onChange, disabled = _a.disabled, props = __rest(_a, ["styles", "wrappedRef", "cx", "className", "hasError", "label", "onChange", "disabled"]);
    var _b = React.useState(false), isFocused = _b[0], setIsFocused = _b[1];
    var _c = React.useState(false), hasContent = _c[0], setHasContent = _c[1];
    var _d = React.useState(0), legendWidth = _d[0], setLegendWidth = _d[1];
    var hiddenLabel = React.useRef(null);
    React.useEffect(function () {
        var labelNode = hiddenLabel.current;
        setLegendWidth(labelNode != null ? labelNode.offsetWidth : 0);
    }, [hiddenLabel]);
    var inputRef = React.useRef(null);
    return (React__default.createElement("fieldset", { className: cx(styles.fieldset, isFocused && "focus", hasContent && "active", hasError && "error", disabled && "disabled", className) },
        React__default.createElement("legend", { className: cx(styles.legend, isFocused && label && "focus", hasContent && label && "active", (isFocused || hasContent) && {
                width: legendWidth
            }, disabled && "disabled") }, label),
        label && (React__default.createElement("span", { ref: hiddenLabel, className: cx(styles.hiddenLabel) }, label)),
        label && (React__default.createElement("div", { className: cx(styles.labelContainer) },
            React__default.createElement("span", { className: cx(styles.label, isFocused && "focus", hasContent && "active", hasError && "error", disabled && "disabled") }, label))),
        React__default.createElement("input", __assign({}, props, { disabled: disabled, ref: inputRef, className: cx(styles.input, disabled && "disabled"), onChange: function (e) {
                if (onChange) {
                    onChange(e);
                }
                setHasContent(e.target.value.length > 0);
            }, onBlur: function () { return setIsFocused(false); }, onFocus: function () { return setIsFocused(true); } }))));
};
var TextInput$1 = withStyles(stylesheet)(TextInput);

var stylesheet$1 = function (theme) { return ({
    errorLabel: __assign({ display: "flex", flexDirection: "column", alignItems: "flex-end", color: theme.colors.alert.alert100 }, theme.typography.label),
    legend: {
        "@selectors": {
            "&.error": {
                color: theme.colors.alert.alert100
            }
        }
    }
}); };
var ExtendedTextInput = TextInput$1.extendStyles(stylesheet$1);
var ErrorTextInput = function (_a) {
    var cx = _a.cx, styles = _a.styles, error = _a.error, className = _a.className, props = __rest(_a, ["cx", "styles", "error", "className"]);
    return (React__default.createElement("div", { className: className },
        React__default.createElement(ExtendedTextInput, __assign({}, props, { hasError: error !== null && error !== undefined })),
        error && typeof error === "string" && (React__default.createElement("div", { className: cx(styles.errorLabel) }, error))));
};
var ErrorTextInput$1 = withStyles(stylesheet$1)(ErrorTextInput);

var styleSheet$7 = function (theme) { return ({
    container: {
        display: "flex",
        flexDirection: "row",
        outlineStyle: "none",
        userSelect: "none",
        cursor: "pointer",
        "@selectors": {
            ":hover .icon:not(.disabled):not(.checked):not(.show-as-checked)": {
                opacity: 1,
                fill: theme.colors.grey.grey100
            },
            "&.disabled": {
                cursor: "initial"
            }
        }
    },
    checkboxText: __assign({ cursor: "inherit" }, theme.typography.body),
    icon: {
        opacity: 0,
        fill: theme.colors.black,
        transition: "0.3s fill, 0.3s opacity",
        "@selectors": {
            "&.show-as-checked": {
                opacity: 1,
                fill: theme.colors.black
            },
            "&.checked": {
                opacity: 1,
                fill: theme.colors.white
            },
            "&.disabled": {
                fill: theme.colors.grey.grey100
            }
        }
    },
    iconContainer: {
        width: theme.spaceUnit.md,
        height: theme.spaceUnit.md,
        border: "1px solid",
        borderColor: theme.colors.black,
        boxSizing: "border-box",
        borderRadius: 2,
        position: "relative",
        backgroundColor: theme.colors.white,
        transition: "0.3s background-color, 0.3s border-color",
        marginRight: theme.spaceUnit.xs,
        display: "flex",
        alignItems: "center",
        justifyContent: "center",
        "@selectors": {
            "&.show-as-checked": {},
            "&.checked": {
                backgroundColor: theme.colors.black
            },
            "&.disabled": {
                backgroundColor: theme.colors.grey.grey25,
                borderColor: theme.colors.grey.grey100
            }
        }
    }
}); };
var defaultCheckedIcon = React__default.createElement(Icon, { name: "check" });
var Checkbox = function (_a) {
    var styles = _a.styles, cx = _a.cx, checked = _a.checked, showAsChecked = _a.showAsChecked, onChange = _a.onChange, _b = _a.checkedIcon, checkedIcon = _b === void 0 ? defaultCheckedIcon : _b, children = _a.children, wrappedRef = _a.wrappedRef, parentStylesheet = _a.parentStylesheet, props = __rest(_a, ["styles", "cx", "checked", "showAsChecked", "onChange", "checkedIcon", "children", "wrappedRef", "parentStylesheet"]);
    var inputRef = React.useRef(null);
    var disabled = props.disabled, name = props.name;
    var _c = React.useState(!!checked), checkedState = _c[0], setCheckedState = _c[1];
    var containerStyle = cx(styles.container, disabled && "disabled");
    var iconContainerStyle = cx(styles.iconContainer, "icon-container", showAsChecked && "show-as-checked", checkedState && "checked", disabled && "disabled");
    var iconStyle = cx(styles.icon, "icon", showAsChecked && "show-as-checked", checkedState && "checked", disabled && "disabled");
    React.useEffect(function () {
        setCheckedState(!!checked);
    }, [checked]);
    var handleInputChange = React.useCallback(function (event) {
        var newChecked = event.target.checked;
        if (checked === undefined && !disabled) {
            setCheckedState(newChecked);
        }
        if (onChange) {
            onChange(event);
        }
    }, [onChange, checked, disabled]);
    var handleClick = React.useCallback(function () {
        var _a;
        var input = inputRef.current;
        return (_a = input) === null || _a === void 0 ? void 0 : _a.click();
    }, []);
    React.useImperativeHandle(wrappedRef, function () { return ({
        isChecked: checkedState,
        toggle: function () { return handleClick(); }
    }); });
    var CheckedIcon = React.useMemo(function () {
        return React__default.cloneElement(checkedIcon, {
            className: iconStyle,
            size: 10
        });
    }, [checkedIcon, iconStyle]);
    return (React__default.createElement("div", { className: containerStyle, onClick: handleClick },
        React__default.createElement("div", { className: iconContainerStyle }, CheckedIcon),
        React__default.createElement("input", __assign({ type: "checkbox" }, props, { onChange: handleInputChange, onClick: function (e) { return e.stopPropagation(); }, checked: checkedState, ref: inputRef, style: { display: "none" }, id: name })),
        React__default.createElement("label", { htmlFor: name, className: cx(styles.checkboxText) }, children)));
};
var Checkbox$1 = withStyles(styleSheet$7)(Checkbox);

var defaultPalette = {
    primary: "#00321E",
    secondary: "",
    alert: {
        alert25: "#D86464",
        alert50: "#D86464",
        alert100: "#D86464"
    },
    warning: {
        warning25: "#fbbc44",
        warning50: "#fbbc44",
        warning100: "#fbbc44"
    },
    success: {
        success25: "#4e9a55",
        success50: "#4e9a55",
        success100: "#4e9a55"
    },
    white: "#ffffff",
    black: "#070707",
    background: {
        background25: "#F8F8F8",
        background50: "",
        background100: "#161616"
    },
    grey: {
        grey25: "#f6f6f6",
        grey50: "#CCCCCC",
        grey100: "#808080"
    }
};

var defaultIcons = {
    add: "add.svg",
    arrow: "arrow.svg",
    arrowDown: "arrow-down.svg",
    block: "block.svg",
    chart: "chart.svg",
    check: "check.svg",
    checkmark: "checkmark.svg",
    close: "close.svg"
};

(function (FontWeight) {
    FontWeight[FontWeight["REGULAR"] = 400] = "REGULAR";
    FontWeight[FontWeight["MEDIUM"] = 500] = "MEDIUM";
    FontWeight[FontWeight["BOLD"] = 700] = "BOLD";
    FontWeight[FontWeight["BOLDER"] = 900] = "BOLDER";
})(exports.FontWeight || (exports.FontWeight = {}));

var spaceUnit = 16;
var fontSize = 18;
var fontFamily = "Arial";
var defaultTheme = {
    name: "default_theme",
    colors: defaultPalette,
    fontFamily: fontFamily,
    fonts: {},
    icons: defaultIcons,
    spaceUnit: {
        xxs: spaceUnit / 4 + "px",
        xs: spaceUnit / 2 + "px",
        sm: spaceUnit / 1.3 + "px",
        md: spaceUnit + "px",
        lg: spaceUnit * 2 + "px",
        xl: spaceUnit * 3 + "px",
        xxl: spaceUnit * 4 + "px"
    },
    spacing: {
        squishsm: {
            top: spaceUnit / 4 + "px",
            left: spaceUnit / 1.3 + "px"
        },
        squishmd: {
            top: spaceUnit / 2 + "px",
            left: spaceUnit + "px"
        },
        squishlg: {
            top: spaceUnit + "px",
            left: spaceUnit * 2 + "px"
        },
        stretchsm: {
            left: spaceUnit / 4 + "px",
            top: spaceUnit / 1.3 + "px"
        },
        stretchmd: {
            left: spaceUnit / 2 + "px",
            top: spaceUnit + "px"
        },
        stretchlg: {
            left: spaceUnit + "px",
            top: spaceUnit * 2 + "px"
        }
    },
    typography: {
        h1: {
            fontSize: "2rem",
            fontWeight: exports.FontWeight.BOLD,
            lineHeight: "46px",
            fontFamily: fontFamily,
            marginBlockStart: 0,
            marginBlockEnd: 0
        },
        h2: {
            fontSize: "1.6rem",
            fontWeight: exports.FontWeight.REGULAR,
            lineHeight: "43px",
            fontFamily: fontFamily,
            marginBlockStart: 0,
            marginBlockEnd: 0
        },
        h3: {
            fontSize: "1.2rem",
            fontWeight: exports.FontWeight.REGULAR,
            lineHeight: "39px",
            fontFamily: fontFamily,
            marginBlockStart: 0,
            marginBlockEnd: 0
        },
        buttonText: {
            fontSize: "1.125rem",
            fontWeight: exports.FontWeight.MEDIUM,
            lineHeight: "24px",
            fontFamily: fontFamily
        },
        descriptionMedium: {
            fontSize: "15px",
            fontWeight: exports.FontWeight.MEDIUM,
            lineHeight: "16px",
            fontFamily: fontFamily
        },
        body: {
            fontSize: fontSize + "px",
            fontWeight: exports.FontWeight.REGULAR,
            lineHeight: fontSize + "px",
            fontFamily: fontFamily
        },
        label: {
            fontSize: "0.66rem",
            fontWeight: exports.FontWeight.REGULAR,
            lineHeight: "0.66rem",
            fontFamily: fontFamily
        }
    }
};

/**
 * An extension for Aphrodite that allows prefixing a selector with "&" to
 * indicate the rest of the selector applies to the currently selected element.
 *
 * E.g.
 * {
 *   button: {
 *     "@selectors": {
 *       "&.error": {
 *         ...styles
 *       }
 *     }
 *   }
 * }
 *
 * The selector "&.error" will apply the given styles to the ".button.error" selector.
 *
 * For more information on how Aphrodite extensions work, please see
 * https://github.com/Khan/aphrodite#advanced-extensions
 *
 * @param selector the current/self selector
 * @param baseSelector the parent selector
 * @param generateSubtreeStyles a function that generates the subtree styles based on the given selector
 */
var selfSelectorHandler = function (selector, baseSelector, generateSubtreeStyles) {
    // Only consider selectors that start with "&" and are followed by an id, class or pseudo-class.
    if (!selector.startsWith("&") ||
        selector.length <= 1 ||
        (selector[1] !== "." && selector[1] !== ":" && selector[1] !== "#")) {
        return null;
    }
    var selfSelector = selector.slice(1);
    return generateSubtreeStyles("" + baseSelector + selfSelector);
};
var selfExtension = { selectorHandler: selfSelectorHandler };

function initDefaultTheme(aesthetic$1) {
    if (aesthetic$1 === void 0) { aesthetic$1 = aesthetic; }
    if (!aesthetic$1.themes[defaultTheme.name]) {
        aesthetic$1.registerTheme(defaultTheme.name, defaultTheme, function (theme) { return ({
            "@global": {},
            "@font-face": theme.fonts
        }); });
    }
    aesthetic$1.configure({
        adapter: new AphroditeAdapter([selfExtension]),
        theme: defaultTheme.name,
        rtl: false,
        extendable: true,
        passThemeProp: true
    });
}
function initTheme(themeObj, aesthetic$1) {
    if (themeObj === void 0) { themeObj = defaultTheme; }
    if (aesthetic$1 === void 0) { aesthetic$1 = aesthetic; }
    if (!aesthetic$1.themes[defaultTheme.name]) {
        aesthetic$1.registerTheme(defaultTheme.name, defaultTheme, function (theme) { return ({
            "@global": {},
            "@font-face": theme.fonts
        }); });
    }
    var result = aesthetic$1.registerTheme(themeObj.name, themeObj, function (theme) { return ({
        "@global": {},
        "@font-face": theme.fonts
    }); });
    aesthetic$1.configure({
        adapter: new AphroditeAdapter([selfExtension]),
        theme: themeObj.name,
        rtl: false,
        extendable: true,
        passThemeProp: true
    });
    return result;
}
function registerTheme(themeObj, aesthetic$1) {
    if (themeObj === void 0) { themeObj = defaultTheme; }
    if (aesthetic$1 === void 0) { aesthetic$1 = aesthetic; }
    aesthetic$1.registerTheme(themeObj.name, themeObj, function (theme) { return ({
        "@global": {},
        "@font-face": theme.fonts
    }); });
    aesthetic$1.configure({
        theme: themeObj.name
    });
}
function changeTheme(theme, aesthetic$1) {
    if (aesthetic$1 === void 0) { aesthetic$1 = aesthetic; }
    aesthetic$1.changeTheme(theme);
}

exports.BaseButton = BaseButton$1;
exports.BaseChip = BaseChip$1;
exports.ButtonText = ButtonText;
exports.Checkbox = Checkbox$1;
exports.CloseableChip = CloseableChip;
exports.DescriptionMedium = DescriptionMedium;
exports.ErrorTextInput = ErrorTextInput$1;
exports.H1 = H1;
exports.H2 = H2;
exports.H3 = H3;
exports.Icon = Icon;
exports.Label = Label;
exports.Radio = Radio$1;
exports.RadioGroup = RadioGroup$1;
exports.StatusChip = StatusChip;
exports.Text = Text;
exports.TextHighlight = TextHighlight;
exports.TextInput = TextInput$1;
exports.changeTheme = changeTheme;
exports.initDefaultTheme = initDefaultTheme;
exports.initTheme = initTheme;
exports.registerTheme = registerTheme;
exports.useStyles = aestheticReact.useStyles;
exports.useTheme = useTheme;
exports.withStyles = withStyles;
//# sourceMappingURL=index.js.map
